{-cd -m}
{$G+,S-,A+,I-,R-,C-}
Uses VGA, SimpLett, MiniCRT, Reals;

Type
  TScreen = array[0..64200] of Byte;
  PScreen = ^TScreen;

Var
  X : Byte;
  l : Word;
  T : TPaintInfo;
  Screen : PScreen;


Procedure SetRGB(c, r, g, b : byte); Assembler;
Asm
  mov dx, 03c8h
  mov al, c
  out dx, al
  inc dx
  mov al, r
  out dx, al
  mov al, g
  out dx, al
  mov al, b
  out dx, al
End;

Procedure StdFeedFire; Far; Assembler;
Asm
  mov ax, L
  ror ax, 1
  xor ax, $aa15
  inc ax
  mov L, ax

  and al, 1
  mov ah, al
  shl ah, 2
  add al, ah
  shl al, 5
  mov byte ptr es:[di], al
End;

Procedure FeedFireNone; Far; Assembler;
Asm
  xor ax, ax
  mov byte ptr es:[di], al
End;

Const
  FeedFire : Pointer = @StdFeedFire;

Procedure DrawFlame; Assembler; Asm
   mov ch, 0 {ch = x, cl = y}
   mov ax, word ptr [Screen+2] {SegA000}
   mov es, ax
   @@x:
   mov cl, 0
   mov al, cl
   xor ah, ah
   mov di, ax
   shl di, 1
   mov al, ch
   dec ax
   shl ax, 1

   shl di, 6
   mov bx, di
   shl bx, 2
      add di, bx
      add di, ax

      @@y:
          add di, 640

          xor dx, dx
          mov al, dh

          mov dl, byte ptr es:[di-2]
          add dl, byte ptr es:[di]
          adc dh, al
          add dl, byte ptr es:[di+2]
          adc dh, al
          add dl, byte ptr es:[di+642]
          adc dh, al

          shr dx, 2

          or dl, dl
          je @@1
          dec dl
       @@1:
          mov dh, dl
          mov word ptr es:[di-320], dx
          mov word ptr es:[di-640], dx

        inc cl
        cmp cl, 101
        jb @@y
        call dword ptr [FeedFire]
      inc ch
      cmp ch, 160
      jb  @@x
End;

Procedure DrawNone; Far; Begin End;

Const
  Freezing : Boolean = False;

Procedure Done; Forward;

Procedure SwapScreen;
Begin
  if (LongInt(Screen) shr 16) <> SegA000 then Move(Screen^, Mem[SegA000:0], 64000);
End;

Procedure  DrawFlameRep(Rep : Word; WithCall : Pointer);
Begin
if WithCall = Nil then WithCall := @DrawNone;
Asm
  mov cx, rep
@@1:
  push cx
  call dword ptr [WithCall]
  call DrawFlame
  {call SwapScreen}
  mov ax, 20
  push ax
  call Delay

  call KeyPressed
  pop cx
  or ax, ax
  je @@2
  call ReadKey
  cmp ax, 011bh
  je @@4
@@2:
  loop @@1
  jmp @@3
@@4:
  call Done
@@3:
End;
End;


Procedure Init;
Begin
  startVGA;
  T.LinePattern := $FFFF;
  T.ClipRect.A.X := 0;
  T.ClipRect.B.X := 320;
  T.ClipRect.A.Y := 0;
  T.ClipRect.B.Y := 200;
  T.Fore := 127;
  T.LineWidth := 2;
  for X := 1 to 32 do  begin
    SetRGB(x, (x shl 1)-1, 0, 0);
    SetRGB(x+32, 63, (x shl 1)-1, 0 );
    SetRGB(x+64, 63, 63, (x shl 1)-1 );
    SetRGB(x+96, 63, 63, 63 );
  end;
  L := $51ac;

  T.GapLength := 3;
  T.FontWidth := 25;
  T.FontHeight := 75;

{  New(Screen);
  if Screen = Nil then Screen := Ptr(SegA000, 0) else FillChar(Screen^, 64200, 0);}
  Screen   := Ptr(SegA000, 0);
  T.Device := Screen;
End;

Procedure Done;
Begin
  if Freezing then Exit;
  Freezing := True;
  FeedFire := @FeedFireNone;
  DrawFlameRep(25, nil);
  EndVGA;
  PrintStr('DK Inc. 1996 Dmitry Karasik AKA Crazy Chickatilo 2:464/46.36@fidonet'#13#10);
  Halt;
End;

Const
  CWriteStr : String = '';
  Mode      : Byte = 0;
Var
  LWD : TSingle;


Procedure CWrite; Far;
Var
  X, Y : Integer;
Begin
  X := (320 - T.FontWidth * (Length(CWriteStr) + 1));
  X := X div 2;
  Y := 200 - T.FontHeight;
  Y := Y div 2;

  SimpWrStr(X, Y, CWriteStr, T);

  case Mode of
  1 : begin
    T.FontWidth  := Int(T.FontWidth  * MakeSingle(1, 2500));
    T.FontHeight := Int(T.FontHeight * MakeSingle(1, 2500));
    LWD.L := Mul(LWD.L, MakeSingle(1, 1600));
    T.LineWidth  := LWD.Int;
  end;
  else end;
End;

Procedure Default;
Begin
  T.FontWidth := 25;
  T.FontHeight := 75;
  Mode := 0;
  T.LineWidth := 2;
  LWD.L := MakeSingle(T.LineWidth, 0);
End;

Begin
  Init;
  Repeat
    DrawFlameRep(35, nil);

    Default;
    CWriteStr := 'Crazy';
    DrawFlameRep(6, @CWrite);
    Mode := 1;
    DrawFlameRep(11, @CWrite);
    DrawFlameRep(30, nil);

    Default;
    CWriteStr := 'Chickatilo';
    DrawFlameRep(6, @CWrite);
    Mode := 1;
    DrawFlameRep(11, @CWrite);
    DrawFlameRep(30, nil);

    Default;
    CWriteStr := '2:464/46.36';
    DrawFlameRep(6, @CWrite);
    Mode := 1;
    DrawFlameRep(11, @CWrite);
    DrawFlameRep(30, nil);

  Until KeyPressed;
  Done;
End.


